/**Construire class toDoList */
export class ToDoList {
    #todos = []
    #listElement = []

    constructor (todos) {
        this.#todos = todos
    }
    appendTo (element) {
        element.innerHTML = `<form class="d-flex pb-4">
        <input required="" class="form-control" type="text" placeholder="Acheter des patates..." name="title" data-com.bitwarden.browser.user-edited="yes">
        <button class="btn btn-primary">Ajouter</button>
    
    </form>
    <main>
        <div class="btn-group mb-4" role="group">
            <button type="button" class=" btn btn-outline-primary active" data-filter = "all">Toutes</button>
            <button type="button" class=" btn btn-outline-primary" data-filter = "todo">A faire</button>
            <button type="button" class=" btn btn-outline-primary" data-filter = "done">Faites</button>
        </div>
        <ul class="list-group">  
        </ul>
    </main>`

    this.#listElement = element.querySelector('.list-group')
        for (let todo of this.#todos) {
            const t = new ToDoListItem(todo) 
            this.#listElement.append(t.element)
        }
        element.querySelector('form').addEventListener('submit', e => this.#onSubmit(e))
        element.querySelectorAll('.btn-group button').forEach(button => {
            button.addEventListener('click', e => this.#toggleFilter(e))
        })
    }
    #onSubmit(e) {
        e.preventDefault()
        const title = new FormData(e.currentTarget).get('title').toString().trim()
           // console.log(title)
        if(title === '') {
            return
        }
        const todo = {
            id: Date.now(),
            title,
            completed: false
        }
        const item = new ToDoListItem(todo);
        this.#listElement.prepend(item.element)

            form.reset()
    }
    #toggleFilter(e) {
        e.preventDefault()
        const filter = e.currentTarget.getAttribute('data-filter');
            //console.log(filter)
        e.currentTarget.parentElement.querySelector('.active').classList.remove('active')
        e.currentTarget.classList.add('active')
        if(filter === 'todo') {
            this.#listElement.classList.add('hide-completed')
            this.#listElement.classList.remove('hide-todo')
        } else if(filter === 'done') {
            this.#listElement.classList.add('hide-todo')
            this.#listElement.classList.remove('hide-completed')
        } else {
            this.#listElement.classList.remove('hide-todo')
            this.#listElement.classList.remove('hide-completed')
        }
    }
}


/*Construire classe iitems des todolist: les li */
import { createElement } from "../functions/F02-DOM.js"

class ToDoListItem {
    #element

    constructor (todo) {
        const id = `todo-${todo.id}`

        const li = createElement('li',{
        class: "todo list-group-item d-flex align-items-center"
        })
        this.#element = li
        
        const checkbox = createElement('input',{
            type: 'checkbox',
            class: 'form-check-input',
            id,
            checked: todo.completed ? '' : null
        })

        const label = createElement('label',{
        class: 'ms-2 form-check-label',
            for: id
        })
        label.innerText = todo.title

        const button = createElement('button',{
            class: 'ms-auto btn btn-danger btn-sm'
        })
         button.innerHTML = '<i class="bi-trash"></i>'

        li.append(checkbox)
        li.append(label)
        li.append(button)
            this.toggle(checkbox)

        button.addEventListener('click', e=> this.remove(e))
        checkbox.addEventListener('change', e=> this.toggle(e.currentTarget))
    }
    appendTo (element) {
        element.append(this.#element)
    }
    remove(e) {
        e.preventDefault()
        this.#element.remove()
    }
    get element() {
        return this.#element
    }
    toggle(checkbox) {
        if(checkbox.checked) {
            this.#element.classList.add('is-completed')
        } else{
            this.#element.classList.remove('is-completed')
        }
    }
}
